/********************************************************
	Interface2012N6t FM3}CR
	CQBB-EL TvvO
*********************************************************/

#include "cpu_init.h"
#include "cpu_uart.h"
#include "tinylib.h"

/* |[gRg[䃌WX^ */
#define GPIO_PFR1   ((volatile unsigned int *)0x40033004)
#define GPIO_PFR4   ((volatile unsigned int *)0x40033010)
#define GPIO_PFR7   ((volatile unsigned int *)0x4003301C)
#define GPIO_PFRF   ((volatile unsigned int *)0x4003303C)
#define GPIO_DDR1   ((volatile unsigned int *)0x40033204)
#define GPIO_DDR4   ((volatile unsigned int *)0x40033210)
#define GPIO_DDR7   ((volatile unsigned int *)0x4003321C)
#define GPIO_DDRF   ((volatile unsigned int *)0x4003323C)
#define GPIO_PDIR1  ((volatile unsigned int *)0x40033304)
#define GPIO_PDIR7  ((volatile unsigned int *)0x4003331C)
#define GPIO_PDIRF  ((volatile unsigned int *)0x4003333C)
#define GPIO_PDOR4  ((volatile unsigned int *)0x40033410)
#define GPIO_PDOR7  ((volatile unsigned int *)0x4003341C)
#define GPIO_ADE	((volatile unsigned int *)0x40033500)


/* 7ZOgLED_p^[`(16i) */
const unsigned char BIN2LED7[] = {
/* 0     1     2     3     4     5     6     7     8     9     A     b     C     d     E     F */
 0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F, 0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71
};


/* CQBB-EL ^NgXCb` */
void PUSHSW_Initialize(void)
{
	/* rbg0(SW2) */
	*GPIO_PFR7  = *GPIO_PFR7  & 0xFFFFDFFF;	/* P7D:GPIOI */
	*GPIO_DDR7  = *GPIO_DDR7  & 0xDFFF;		/* P7D:͕ */
	/* rbg3`1(SW5`3) */
	*GPIO_PFRF  = *GPIO_PFRF  & 0xFFFFFFF8;	/* PF2`F0:GPIOI */
	*GPIO_DDRF  = *GPIO_DDRF  & 0xFFF8;		/* PF2`F0:͕ */
}

/* CQBB-EL ^NgXCb`Ԏ擾 */
int PUSHSW_GetSW(void)
{
	return ( (
		((*GPIO_PDIRF <<  1) & 0xE)	/* rbg3`1:PF2`0 */
		 |
		((*GPIO_PDIR7 >> 13) & 0x1)	/* rbg0:P7D */
	) ^ 3);	/* rbg1/0̂ݘ_](_̂) */
}


/* CQBB-EL fBbvXCb`͏ */
void DIPSW_Initialize(void)
{
	*GPIO_ADE   = *GPIO_ADE   & 0xFFFFF00F;	/* A-D̓`l11(P1B)`4(P14):fBZ[u */
	*GPIO_PFR1  = *GPIO_PFR1  & 0x00000FF0;	/* P1B`P14:GPIOI */
	*GPIO_DDR1  = *GPIO_DDR1  & 0xF00F;		/* P1B`P14:͕ */
}

/* CQBB-EL fBbvXCb`Ԏ擾 */
int DIPSW_GetSW(void)
{
	return ( (~(*GPIO_PDIR1 >> 4)) & 0xFF);	/* _Ȃ̂Ř_] */
}


/* CQBB-EL 7ZOgLED */
void LED7_Initialize(void)
{
	/* LED_ */
	*GPIO_PFR4  = *GPIO_PFR4  & 0xFFFF83FF;	/* P4E`P4A:GPIOI */
	*GPIO_PFR7  = *GPIO_PFR7  & 0xFFFFF800;	/* P7A`P70:GPIOI */
	*GPIO_PDOR4 = *GPIO_PDOR4 | 0x7C00;		/* P4E`P4A:"H"xo */
	*GPIO_PDOR7 = *GPIO_PDOR7 | 0x07FF;		/* P7A`P70:"H"xo */
	*GPIO_DDR4  = *GPIO_DDR4  | 0x7C00;		/* P4E`P4A:o͕ */
	*GPIO_DDR7  = *GPIO_DDR7  | 0x07FF;		/* P7A`P70:o͕ */
}

/* CQBB-EL 7ZOgʌLED_ */
void LED7h_SetLED(int d)
{
	/* rbg7:P7A ` rbg0:P73 (_) */
	*GPIO_PDOR7 = (*GPIO_PDOR7 & 0xF807) | ((~d & 0xFF) <<  3);
}

/* CQBB-EL 7ZOgʌLED_ */
void LED7l_SetLED(int d)
{
	/* rbg7:P72 ` rbg5:P70 (_) */
	*GPIO_PDOR7 = (*GPIO_PDOR7 & 0xFFF8) | ((~d & 0xE0) >>  5);
	/* rbg4:P4E ` rbg0:P4A (_) */
	*GPIO_PDOR4 = (*GPIO_PDOR4 & 0x83FF) | ((~d & 0x1F) << 10);
}



int main(void)
{
	int i, sw, count;

	/* CPUŗL */
	CPU_Initialize();

	/* R\[pUART */
	CPU_UartInitialize();

	/* CQBB-EL 7ZOgLED */
	LED7_Initialize();

	/* CQBB-EL fBbvXCb`͏ */
	DIPSW_Initialize();

	/* CQBB-EL ^NgXCb` */
	PUSHSW_Initialize();

	/* 7ZOg fBbvXCb`ԕ\ */
	count = DIPSW_GetSW();
	LED7l_SetLED( BIN2LED7[ (count % 16) ]); /* ʌ */
	LED7h_SetLED( BIN2LED7[ (count / 16) ]); /* ʌ */

	/* NbZ[WUARTɏo */
	t_printf("\nFM3 + CQBB-EL sample program\n");

	while(1){

		while(1){
			/* vbVXCb`̏Ԏ擾 */
			sw = PUSHSW_GetSW();
			/* SW2vbV JEg + 1 */
			if (sw & 1) count = count + 1;
			/* SW3vbV fBbvXCb`Ԃ[h */
			if (sw & 2) count = DIPSW_GetSW();
			/* SW4vbV JEg 0xFF */
			if (sw & 4) count = 0xFF;
			/* SW5vbV JEg - 1 */
			if (sw & 8) count = count - 1;
			if (sw) break;
		}
		count = count & 0xFF;

		/* 7ZOg LEDJEgl\ */
		LED7l_SetLED( BIN2LED7[ (count % 16) ]); /* ʌ */
		LED7h_SetLED( BIN2LED7[ (count / 16) ]); /* ʌ */

		/* lUARTɏo */
		t_printf("count = %02Xh\n", count);

		/* L[܂ő҂ */
		while(PUSHSW_GetSW()){}

	}

}
