/***************************************************************
 CPU UART VAR\[o̓hCo(FM3 MFSp)
***************************************************************/

/* UARTRg[ */

#define	USE_BPS		115200	/* ʐMx 115200 or 38400 */

#define	USE_UART_CH		4	/* UART`l0 or 3 or 4 */


#if (USE_BPS == 115200)
	/* APB2oXNbN36MHz */
	#define MFSx_BGR_SET (312)
#endif
#if (USE_BPS == 38400)
	/* APB2oXNbN36MHz */
	#define MFSx_BGR_SET (936)
#endif

#if (USE_UART_CH == 0)
	/* MFSRg[0 */
	#define BaseAddr (0x40038000)
#endif
#if (USE_UART_CH == 3)
	/* MFSRg[3 */
	#define BaseAddr (0x40038300)
#endif
#if (USE_UART_CH == 4)
	/* MFSRg[4 */
	#define BaseAddr (0x40038400)
#endif


/* FIFOtVARg[SCIF(SCIFx) */
#define MFSx_SMR	((volatile unsigned char      *)(BaseAddr+0x000))
#define MFSx_SCR	((volatile unsigned char      *)(BaseAddr+0x001))
#define MFSx_ESCR	((volatile unsigned char      *)(BaseAddr+0x004))
#define MFSx_SSR	((volatile unsigned char      *)(BaseAddr+0x005))
#define MFSx_RDR	((volatile unsigned char      *)(BaseAddr+0x008))
#define MFSx_TDR	((volatile unsigned char      *)(BaseAddr+0x008))
#define MFSx_BGR	((volatile unsigned short int *)(BaseAddr+0x00C))
#define MFSx_FCR0	((volatile unsigned char      *)(BaseAddr+0x014))
#define MFSx_FCR1	((volatile unsigned char      *)(BaseAddr+0x015))
#define MFSx_FBYTE	((volatile unsigned short int *)(BaseAddr+0x018))

/* |[gRg[䃌WX^ */
#define GPIO_PFR0	((volatile unsigned int       *)(0x40033000))
#define GPIO_PFR2	((volatile unsigned int       *)(0x40033008))
#define GPIO_PFR4	((volatile unsigned int       *)(0x40033010))
#define GPIO_ADE	((volatile unsigned int       *)(0x40033500))
#define GPIO_EPFR07	((volatile unsigned int       *)(0x4003361C))
#define GPIO_EPFR08	((volatile unsigned int       *)(0x40033620))



/* R\[(UART) */
void CPU_UartInitialize(void)
{
	unsigned short int sts;
#if (USE_UART_CH == 0)
	/* P[gsI  SIN0_0()CSOT0_0(o)gp */
	*GPIO_EPFR07 = (*GPIO_EPFR07 & 0xFFFFFF00) | 0x00000000;
	/* |[g2t@NVI */
	*GPIO_PFR2 = *GPIO_PFR2 | 0x00000006;	/* P22P21Ӌ@\ƂĎgp */
	/* A-D͋֎~ */
	*GPIO_ADE  = *GPIO_ADE & 0x7FFFFFFF;	/* AN31fBZ[u(SOT0_0L) */
#endif
#if (USE_UART_CH == 3)
	/* P[gsI  SIN3_2()CSOT3_2(o)gp */
	*GPIO_EPFR07 = (*GPIO_EPFR07 & 0xFC3FFF00) | 0x03C00000;
	/* |[g2t@NVI */
	*GPIO_PFR4 = *GPIO_PFR4 | 0x00000300;	/* P49P48Ӌ@\ƂĎgp */
#endif
#if (USE_UART_CH == 4)
	/* P[gsI  SIN4_2()CSOT4_2(o)gp */
	*GPIO_EPFR08 = (*GPIO_EPFR08 & 0xFFFFFF0F) | 0x000000F0;
	/* |[g0t@NVI */
	*GPIO_PFR0 = *GPIO_PFR0 | 0x00000060;	/* P06P05Ӌ@\ƂĎgp */
/*	   P[gsI  SIN4_2()CSOT4_2(o)CCTS4_2()CRTS4_2(o)gp */
/*	*GPIO_EPFR08 = (*GPIO_EPFR08 & 0xFFFFFF00) | 0x000000FF; */
/*     |[g0t@NVI */
/*	*GPIO_PFR0 = *GPIO_PFR0 | 0x00000360;	/* P09,P08,P06,P05Ӌ@\ƂĎgp */
	/* t[M܂Ŏgpꍇ */

#endif

	/* MFSxݒ */
	*MFSx_SCR = 0x80;	/* MFS\tgEFAZbg */
	*MFSx_SCR = 0x00;	/* MFS\tgEFAZbg */
	*MFSx_SMR = 0x00;	/* UART0[hCXgbvrbg1CLSBt@[Xg */
	*MFSx_ESCR= 0x00;	/* Xgbvrbg1CNRZCpeBCf[^rbg8 */
	*MFSx_BGR = MFSx_BGR_SET; /* ݒ */
	*MFSx_FCR0= 0x00;	/* FIFOfBZ[u */
	*MFSx_FCR1= 0x00;
	*MFSx_SMR = 0x01;	/* UART0[hCXgbvrbg1CLSBt@[XgCMo͋ */
	*MFSx_SCR = 0x03;	/* M */
}

/* R\[1o */
void CPU_UartPutch(unsigned char data)
{
	while(1){
		if (*MFSx_SSR & 0x02 ) {	/* Mobt@󂢂Ă邩 */
			*MFSx_TDR = data;		/* Mf[^ */
			break;
		}
	}
}

/* R\[o(\n CR+LFo) */
void CPU_UartPuts(unsigned char *buffer)
{
	unsigned char data;
	while( (data = *(buffer++)) != 0){	/* null܂ŏo */
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[o(񒷂wt/\n CR+LFo) */
void CPU_UartPutsL(unsigned char *buffer, int len)
{
	int i;
	unsigned char data;
	for(i=0;i<len;i++){
		data=*(buffer++);
		if (data == 0x0a) {
			CPU_UartPutch(0x0d);	/* CRo */
			CPU_UartPutch(0x0a);	/* LFo */
		} else {
			CPU_UartPutch(data);	/* 1o */
		}
	}
}

/* R\[̓obt@`FbN */
int CPU_UartRecvCheck(void)
{
	unsigned short int sts;
	if (*MFSx_SSR & 0x38) {	/* eG[ԊmF */
		*MFSx_SSR = 0x80; /* eMG[NA */
	}
	if (*MFSx_SSR & 0x04) {	/* Mf[^ */
		return 1;	/* Mf[^ */
	} else {
		return 0;	/* Mf[^Ȃ */
	}
}

/* R\[1(GR[obNȂ) */
unsigned char CPU_UartGetch(void)
{
	unsigned char data;
	while(1){
		if (CPU_UartRecvCheck()) {	/* f[^M */
			data = *MFSx_RDR;	/* Mf[^ǂݏo */
			break;
		}
	}
	return data;
}

/* R\[(CRR[h܂/ő255/GR[obN) */
int CPU_UartGets(unsigned char *buffer)
{
	unsigned char data;
	int i;
	i=0;
	while(1){
		data = CPU_UartGetch();	/* 1 */
		*buffer = data;
		CPU_UartPutch(data);	/* 1o(GR[obN) */
		buffer++;
		i++;
		if (i > 255) break;		/* ő啶ɒB */
		if (data == 0x0D) break;/* CRR[h܂ŎM */
	}
	*buffer=(unsigned char)0;	/* nullR[h */
	return i;					/* ͕ */
}

